<?php

namespace App\Models\Shopify;

use Illuminate\Database\Eloquent\Model;
use DB;
class Spysummarypayouttransaction extends Model
{
    protected $connection = 'shopify';
    protected $dates = [''];
    protected $table = 'spy_summary_payout_transaction';
    protected $rules = array();

    protected $injectUniqueIdentifier = true;

    public static function fetchPayoutTrans($seller_id,$trsid)
    {
    	$SpyorderObj = Spysummarypayouttransaction::where("seller_id",$seller_id)->where('transaction_id',$trsid)->first();

    	return $SpyorderObj;
    }
    public static function fetchPayoutTransAll($seller_id,$module,$name,$value)
    {
        $SpyorderObj = Spysummarypayouttransaction::select('*',DB::raw("sum(amount) as sumAmount"))->where("seller_id",$seller_id)->where("module",$module)->where($name,$value)->groupby(['order_transaction_id','type'])->orderby('processed_at')->where('spy_summary_payout_transaction.type', '!=', 'payout')
        ->get();
        if(!empty($SpyorderObj)){
            $SpyorderObj = $SpyorderObj->toArray();
        }
        return $SpyorderObj;
    }
    public static function updatePayoutAmount($seller_id,$module,$name,$value)
    {
        $duplicateIdsSum = Spysummarypayouttransaction::select([DB::raw("order_transaction_id"),DB::raw("sum(amount) as sumAmount"),DB::raw("COUNT(*) AS no_of_order")])->where("seller_id",$seller_id)->where("module",$module)->where($name,$value)->whereNotNull('order_transaction_id')->where('spy_summary_payout_transaction.type', '!=', 'payout')->groupby(['order_transaction_id'])->having(DB::raw('no_of_order'), '>', 1)->get();
        //pr($duplicateIdsSum);
        if(!empty($duplicateIdsSum)){

            foreach($duplicateIdsSum as $SpyorderObj){
               $Spysummarypayouttransaction = Spysummarypayouttransaction::where("order_transaction_id",$SpyorderObj->order_transaction_id)->where("seller_id",$seller_id)->where("module",$module)->where('spy_summary_payout_transaction.type', '!=', 'payout')->whereNotNull('order_transaction_id')->orderBy("transaction_id", "asc")->get();
                $i=0;
                foreach($Spysummarypayouttransaction as $Spysummarypayouttrn){
                    if($Spysummarypayouttrn['type']=="charge" && $i==0){
                        $Spysummarypayouttrn->amount=$SpyorderObj->sumAmount;
                        $Spysummarypayouttrn->net=$SpyorderObj->sumAmount-$Spysummarypayouttrn['fee'];
                        $i++;
                    }else{
                        $Spysummarypayouttrn->amount=0;
                        $Spysummarypayouttrn->net=0;
                        $Spysummarypayouttrn->fee=0;
                    }
                    $Spysummarypayouttrn->save();
                }
            }
            return true;
        }
    }
}
