<?php
return [    
    'summary_setting_fields' => array(
        'common'=>array(
            'product_sales'=>array(
                'label' => 'Amazon Sales',
                'field_name' => 'product_sales',
                'field_info' => 'Product Sales info',
                'tally_acc_type' => array('Sales Accounts', 'Current Liabilities'),
                'tally_account_create_type'=>'Sales Accounts',
                'tally_account_code' => 'PSH01',
            ),
            'product_refunds'=>array(
                'label' => 'Amazon Refunds',
                'field_name' => 'product_refunds',
                'field_info' => 'Product Refunds info',
                'tally_acc_type' => array('Sales Accounts', 'Current Liabilities'),
                'tally_account_create_type'=>'Sales Accounts',
                'tally_account_code' => 'PSH02',
            ),
            'shipping'=>array(
                'label' => 'Amazon Shipping Income',
                'field_name' => 'shipping',
                'field_info' => 'Shipping info',
                'tally_acc_type' => array('Sales Accounts', 'Current Liabilities'),
                'tally_account_create_type'=>'Sales Accounts',
                'tally_account_code' => 'PSH03',
            ),
            'tax'=>array(
                'label' => 'Amazon Sales Tax',
                'field_name' => 'tax',
                'field_info' => 'Tax info',
                'tally_acc_type' => array('Sales Accounts', 'Current Liabilities'),
                'tally_account_create_type'=>'Current Liabilities',
                'tally_account_code' => 'PSH04',
            ),
        ),
        'fees'=>array(
            'amazon_advertising'=>array(
                'label' => 'Amazon Advertising',
                'field_name' => 'amazon_advertising',
                'field_info' => 'Amazon Advertising info',
                'tally_acc_type' => array('Sales Accounts', 'Direct Expenses'),
                'tally_account_create_type'=>'Direct Expenses',
                'tally_account_code' => 'PSH05',
            ),
            'commissions_and_selling_fees'=>array(
                'label' => 'Amazon Seller Fees',
                'field_name' => 'commissions_and_selling_fees',
                'field_info' => 'Commissions and Selling Fees info',
                'tally_acc_type' => array('Sales Accounts', 'Direct Expenses'),
                'tally_account_create_type'=>'Direct Expenses',
                'tally_account_code' => 'PSH06',
            ),
            'amazon_loans'=>array(
                'label' => 'Amazon Loans',
                'field_name' => 'amazon_loans',
                'field_info' => 'Lending info',
                'tally_acc_type' => array('Sales Accounts', 'Current Liabilities'),
                'tally_account_create_type'=>'Current Liabilities',
                'tally_account_code' => 'PSH07',
            ),
            'promotions'=>array(
                'label' => 'Amazon Promotions',
                'field_name' => 'promotions',
                'field_info' => 'Promotions info',
                'tally_acc_type' => array('Sales Accounts', 'Direct Expenses'),
                'tally_account_create_type'=>'Direct Expenses',         
                'tally_account_code' => 'PSH08',
            ),  
        ),
        'other'=>array(
            'fba_fees'=>array(
                'label' => 'Amazon FBA Fees',
                'field_name' => 'fba_fees',
                'field_info' => 'Fulfilment and Warehousing info',
                'tally_acc_type' => array('Sales Accounts', 'Direct Expenses'),
                'tally_account_create_type'=>'Direct Expenses',
                'tally_account_code' => 'PSH09',
            ),
            'reimbursements'=>array(
                'label' => 'Amazon Reimbursements',
                'field_name' => 'reimbursements',
                'field_info' => 'Reimbursements info',
                'tally_acc_type' => array('Sales Accounts', 'Direct Expenses'),
                'tally_account_create_type'=>'Direct Expenses',
                'tally_account_code' => 'PSH10',
            ),
	       'reserved_balance'=>array(
                'label' => 'Amazon Reserved Balances',
                'field_name' => 'reserved_balance',
                'field_info' => 'Reserved Balance info',
                'tally_acc_type' => array('Sales Accounts', 'Direct Expenses'),
                'tally_account_create_type'=>'Direct Expenses',
                'tally_account_code' => 'PSH11',
            ),
	       'other'=>array(
                'label' => 'Amazon Other',
                'field_name' => 'other',
                'field_info' => 'Other info',
                'tally_acc_type' => array('Sales Accounts', 'Direct Expenses'),
                'tally_account_create_type'=>'Direct Expenses',
                'tally_account_code' => 'PSH12',
            )
        )
    ),
    'tax_inclusive_currency'=>array('GBP'),
    'tax_fields'=> array('sales'=>'Principal','tax'=>array('Tax','MarketplaceFacilitatorTax-Principal','LowValueGoodsTax-Principal','MarketplaceFacilitatorVAT-Principal','TaxDiscount')),
    'shipping_tax_fields'=> array('sales'=>'Shipping','tax'=>array('ShippingTax','MarketplaceFacilitatorTax-Shipping','LowValueGoodsTax-Shipping','MarketplaceFacilitatorVAT-Shipping','TaxDiscount')),
    'fees_keys'=>array('ItemFees','other-transaction'),
];